#ifndef CYGONCE_HAL_ARCH_INC
#define CYGONCE_HAL_ARCH_INC
//=============================================================================
//
//	arch.inc
//
//	NIOS assembler header file
//
//=============================================================================
//###ECOSGPLCOPYRIGHTBEGIN####
// -------------------------------------------
// This file is part of eCos, the Embedded Configurable Operating System.
// Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
//
// eCos is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later version.
//
// eCos is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with eCos; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
//
// As a special exception, if other files instantiate templates or use macros
// or inline functions from this file, or you compile this file and link it
// with other works to produce a work based on this file, this file does not
// by itself cause the resulting work to be covered by the GNU General Public
// License. However the source code for this file must still be made available
// in accordance with section (3) of the GNU General Public License.
//
// This exception does not invalidate any other reasons why a work based on
// this file might be covered by the GNU General Public License.
//
// Alternative licenses for eCos may be arranged by contacting Red Hat, Inc.
// at http://sources.redhat.com/ecos/ecos-license/
// -------------------------------------------
//###ECOSGPLCOPYRIGHTEND####
//=============================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s): 	Hao Tseng
// Contributors:	
// Date:	
// Purpose:	Architecture definitions.
// Description:	This file contains various definitions and macros that are
//              useful for writing assembly code for the NIOS CPU family.
// Usage:
//		#include <cyg/hal/arch.inc>
//		...
//		
//
//####DESCRIPTIONEND####
//
//=============================================================================

//-----------------------------------------------------------------------------

#define SAVED_REGS_SIZE (34*4)

//--------------------------------------------------------------------------
// Execption vectors definition

// Vector definition 
// Reset, CWP underflow/overflow must be handled
#define CYGNUM_HAL_VECTOR_RESET                 0                 
#define CYGNUM_HAL_VECTOR_CWP_UNDERFLOW         1
#define CYGNUM_HAL_VECTOR_CWP_OVERFLOW          2
#define CYGNUM_HAL_VECTOR_TRAP                  3
#define CYGNUM_HAL_VECTOR_4                     4
#define CYGNUM_HAL_VECTOR_5                     5
#define CYGNUM_HAL_VECTOR_6                     6
#define CYGNUM_HAL_VECTOR_7                     7
#define CYGNUM_HAL_VECTOR_8                     8
#define CYGNUM_HAL_VECTOR_9                     9
#define CYGNUM_HAL_VECTOR_10                    10
#define CYGNUM_HAL_VECTOR_11                    11
#define CYGNUM_HAL_VECTOR_12                    12
#define CYGNUM_HAL_VECTOR_13                    13
#define CYGNUM_HAL_VECTOR_14                    14
#define CYGNUM_HAL_VECTOR_15                    15
#define CYGNUM_HAL_VECTOR_16                    16
#define CYGNUM_HAL_VECTOR_17                    17
#define CYGNUM_HAL_VECTOR_18                    18
#define CYGNUM_HAL_VECTOR_19                    19
#define CYGNUM_HAL_VECTOR_20                    20
#define CYGNUM_HAL_VECTOR_21                    21
#define CYGNUM_HAL_VECTOR_22                    22
#define CYGNUM_HAL_VECTOR_23                    23
#define CYGNUM_HAL_VECTOR_24                    24
#define CYGNUM_HAL_VECTOR_25                    25
#define CYGNUM_HAL_VECTOR_26                    26
#define CYGNUM_HAL_VECTOR_27                    27
#define CYGNUM_HAL_VECTOR_28                    28
#define CYGNUM_HAL_VECTOR_29                    29
#define CYGNUM_HAL_VECTOR_30                    30
#define CYGNUM_HAL_VECTOR_31                    31
#define CYGNUM_HAL_VECTOR_32                    32
#define CYGNUM_HAL_VECTOR_33                    33
#define CYGNUM_HAL_VECTOR_34                    34
#define CYGNUM_HAL_VECTOR_35                    35
#define CYGNUM_HAL_VECTOR_36                    36
#define CYGNUM_HAL_VECTOR_37                    37
#define CYGNUM_HAL_VECTOR_38                    38
#define CYGNUM_HAL_VECTOR_39                    39
#define CYGNUM_HAL_VECTOR_40                    40
#define CYGNUM_HAL_VECTOR_41                    41
#define CYGNUM_HAL_VECTOR_42                    42
#define CYGNUM_HAL_VECTOR_43                    43
#define CYGNUM_HAL_VECTOR_44                    44
#define CYGNUM_HAL_VECTOR_45                    45
#define CYGNUM_HAL_VECTOR_46                    46
#define CYGNUM_HAL_VECTOR_47                    47
#define CYGNUM_HAL_VECTOR_48                    48
#define CYGNUM_HAL_VECTOR_49                    49
#define CYGNUM_HAL_VECTOR_50                    50
#define CYGNUM_HAL_VECTOR_51                    51
#define CYGNUM_HAL_VECTOR_52                    52
#define CYGNUM_HAL_VECTOR_53                    53
#define CYGNUM_HAL_VECTOR_54                    54
#define CYGNUM_HAL_VECTOR_55                    55
#define CYGNUM_HAL_VECTOR_56                    56
#define CYGNUM_HAL_VECTOR_57                    57
#define CYGNUM_HAL_VECTOR_58                    58
#define CYGNUM_HAL_VECTOR_59                    59
#define CYGNUM_HAL_VECTOR_60                    60
#define CYGNUM_HAL_VECTOR_61                    61
#define CYGNUM_HAL_VECTOR_62                    62
#define CYGNUM_HAL_VECTOR_63                    63


#define CYGNUM_HAL_VSR_MIN              CYGNUM_HAL_VECTOR_RESET
#define CYGNUM_HAL_VSR_MAX              CYGNUM_HAL_VECTOR_63
#define CYGNUM_HAL_VSR_COUNT            (CYGNUM_HAL_VSR_MAX - CYGNUM_HAL_VSR_MIN +1)


// Exception & interrupt count 
#define CYGNUM_HAL_EXCEPTION_TRAP      CYGNUM_HAL_VECTOR_TRAP
#define CYGNUM_HAL_EXCEPTION_DIV0      CYGNUM_HAL_VECTOR_4
 
#define CYGNUM_HAL_EXCEPTION_MIN       CYGNUM_HAL_EXCEPTION_TRAP
#define CYGNUM_HAL_EXCEPTION_MAX       CYGNUM_HAL_EXCEPTION_DIV0
#define CYGNUM_HAL_EXCEPTION_COUNT     (CYGNUM_HAL_EXCEPTION_MAX - CYGNUM_HAL_EXCEPTION_MIN + 1)

#define CYGNUM_HAL_ISR_MIN             CYGNUM_HAL_VECTOR_5
#define CYGNUM_HAL_ISR_MAX             CYGNUM_HAL_VECTOR_63
#define CYGNUM_HAL_ISR_COUNT           (CYGNUM_HAL_ISR_MAX - CYGNUM_HAL_ISR_MIN +1 )




#endif // ifndef CYGONCE_HAL_ARCH_INC
//# end of arch.inc
