##=============================================================================
##
##	platform.s
##
##	NIOS mini platform code
##
##=============================================================================
#####ECOSGPLCOPYRIGHTBEGIN####
## -------------------------------------------
## This file is part of eCos, the Embedded Configurable Operating System.
## Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
##
## eCos is free software; you can redistribute it and/or modify it under
## the terms of the GNU General Public License as published by the Free
## Software Foundation; either version 2 or (at your option) any later version.
##
## eCos is distributed in the hope that it will be useful, but WITHOUT ANY
## WARRANTY; without even the implied warranty of MERCHANTABILITY or
## FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
## for more details.
##
## You should have received a copy of the GNU General Public License along
## with eCos; if not, write to the Free Software Foundation, Inc.,
## 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
##
## As a special exception, if other files instantiate templates or use macros
## or inline functions from this file, or you compile this file and link it
## with other works to produce a work based on this file, this file does not
## by itself cause the resulting work to be covered by the GNU General Public
## License. However the source code for this file must still be made available
## in accordance with section (3) of the GNU General Public License.
##
## This exception does not invalidate any other reasons why a work based on
## this file might be covered by the GNU General Public License.
##
## Alternative licenses for eCos may be arranged by contacting Red Hat, Inc.
## at http://sources.redhat.com/ecos/ecos-license/
## -------------------------------------------
#####ECOSGPLCOPYRIGHTEND####
##=============================================================================
#######DESCRIPTIONBEGIN####
##
## Author(s): 	 Hao Tseng
## Contributors: 
## Date:	 2003/12/15
## Purpose:	
## Description:	 NIOS MINI platform code
##              
######DESCRIPTIONEND####
##
##=============================================================================

#include <pkgconf/system.h>	
#include <pkgconf/hal.h>
#include <cyg/hal/arch.inc>
#include <cyg/hal/nios_imacros.inc>
#include <pkgconf/hal_nios_mini.h>

//-----------------------------------------------------------------------------
// (1) Platform Reset
//
    .text
    .globl hal_platform_reset
hal_platform_reset:

    // Initial basic hardware, such as DRAM , cache...
    
  #if CYGHWR_NIOS_DIAG_USE_UART
    // Disable diagnostic UART's interrupt
    MOVIP   %l0, CYGHWR_NIOS_DIAG_UART_ADDRESS
    MOVI    %o0,0
    STP     [%l0, 3], %o0
  #endif    

    // Disable RTC's interrupt
    MOVIP   %l0, CYGHWR_NIOS_RTC_ADDRESS        
    MOVI    %o0,0x8
    STP     [%l0, 1], %o0
    
    // clear RTC flag
    MOVIP %o0, 0x1
    STP    [%l0, 0],%o0
        
    JMP	%o7
    NOP

//-----------------------------------------------------------------------------
// (2) Interrupt pre_process
//
//  In this function can't use save or resotre instruction , 
//  it will destoriy the stack.

    .text
    .globl hal_platform_intr_pre_process
hal_platform_intr_pre_process:

    RDCTL   %g0
    ANDIP   %g0,0x7e00
    LSRI    %g0,9                   ;Let %g0 = IPRI

    ; Clear peripheral's interrupt
    
    ;Is this Interrupt for RTC ?
    MOV     %g1,%g0    
    SUBIP   %g1,CYGHWR_NIOS_RTC_VECTOR
    SKPS    cc_eq
    BR      _intr_pre_proc_exit
    NOP
    
_clear_RTC_intr:
    // clear RTC flag
    MOVIP %g1,CYGHWR_NIOS_RTC_ADDRESS    
    MOVIP %g2, 0x1
    ST    [%g1],%g2

_intr_pre_proc_exit:    
    JMP	%o7
    NOP
        

##-----------------------------------------------------------------------------
## end of platform.S
	
